import { world, system, BlockTypes, ItemStack, BlockPermutation, BlockType } from "@minecraft/server";


import { showMainMenuForm } from './forms/mainMenuForm';


import giveASingleBook from "./util/give-a-single-book";

const BOOK_ID = "jfc_apples:guide_book" // Change this to be the name of your book item.

world.afterEvents.itemUse.subscribe(event => {
    if (event.itemStack.typeId != "jfc_apples:guide_book") return;

    const player = event.source;

	showMainMenuForm(player)
  
   
})


giveASingleBook({
	itemTypeId: BOOK_ID
});





world.afterEvents.itemUse.subscribe(event => {
    if (event.itemStack.typeId != "jfc_apples:guide_book") return;

    const player = event.source;

	showMainMenuForm(player)
   
})



system.runInterval(() => {
  const players = world.getPlayers();

  if (players.length === 0) {
      return;
  }

  const player = players[0]; // Get the first player
  const inventory = player.getComponent("minecraft:inventory")?.container;

  if (!inventory) {
      console.warn("Inventory component not found.");
      return;
  }

  // Define the namespace prefix
  const namespacePrefix = "jfc_apples:";

  for (let i = 0; i < inventory.size; i++) {
      const item = inventory.getItem(i);
      
      // Check if the item ID starts with the namespace
      if (item && item.typeId.startsWith(namespacePrefix)) {
          item.setLore(["§2[Apples+ Add-On]"]); // Modify lore
          inventory.setItem(i, item); // Save changes
          console.log(`Lore added to: ${item.typeId}`);
      }
  }
}, 4);



const radius = 5;

// Define ore types and their corresponding drops with min/max amounts
const ORE_DROPS = {
    "minecraft:coal_ore": { drop: "minecraft:coal", min: 1, max: 1 },
    "minecraft:iron_ore": { drop: "minecraft:raw_iron", min: 1, max: 1 },
    "minecraft:copper_ore": { drop: "minecraft:raw_copper", min: 2, max: 5 },
    "minecraft:gold_ore": { drop: "minecraft:raw_gold", min: 1, max: 1 },
    "minecraft:redstone_ore": { drop: "minecraft:redstone", min: 4, max: 5 },
    "minecraft:lit_redstone_ore": { drop: "minecraft:redstone", min: 4, max: 5 },
    "minecraft:lapis_ore": { drop: "minecraft:lapis_lazuli", min: 4, max: 9 },
    "minecraft:diamond_ore": { drop: "minecraft:diamond", min: 1, max: 1 },
    "minecraft:emerald_ore": { drop: "minecraft:emerald", min: 1, max: 1 },
    "minecraft:quartz_ore": { drop: "minecraft:quartz", min: 1, max: 1 },
    "minecraft:nether_gold_ore": { drop: "minecraft:gold_nugget", min: 2, max: 6 },
    "minecraft:ancient_debris": { drop: "minecraft:ancient_debris", min: 1, max: 1 },
    "minecraft:deepslate_coal_ore": { drop: "minecraft:coal", min: 1, max: 1 },
    "minecraft:deepslate_iron_ore": { drop: "minecraft:raw_iron", min: 1, max: 1 },
    "minecraft:deepslate_copper_ore": { drop: "minecraft:raw_copper", min: 2, max: 5 },
    "minecraft:deepslate_gold_ore": { drop: "minecraft:raw_gold", min: 1, max: 1 },
    "minecraft:deepslate_redstone_ore": { drop: "minecraft:redstone", min: 2, max: 5 },
    "minecraft:lit_deepslate_redstone_ore": { drop: "minecraft:redstone", min: 2, max: 5 },
    "minecraft:deepslate_lapis_ore": { drop: "minecraft:lapis_lazuli", min: 4, max: 9 },
    "minecraft:deepslate_diamond_ore": { drop: "minecraft:diamond", min: 1, max: 1 },
    "minecraft:deepslate_emerald_ore": { drop: "minecraft:emerald", min: 1, max: 1 },
    "minecraft:amethyst_cluster": { drop: "minecraft:amethyst_shard", min: 4, max: 4 }
};

// Function to mine ores around a player
function mineNearbyOres(player) {
    const playerLocation = player.location;
    const dimension = player.dimension;

    for (let x = -radius; x <= radius; x++) {
        for (let y = -radius; y <= radius; y++) {
            for (let z = -radius; z <= radius; z++) {
                let blockLocation = {
                    x: Math.floor(playerLocation.x) + x,
                    y: Math.floor(playerLocation.y) + y,
                    z: Math.floor(playerLocation.z) + z
                };

                let block = dimension.getBlock(blockLocation);
                if (!block) continue;

                // Check if the block is in our ore list
                if (ORE_DROPS.hasOwnProperty(block.typeId)) {
                    let oreData = ORE_DROPS[block.typeId];

                    // Break the block
                    block.setType(BlockTypes.get("minecraft:air"));

                    // Determine the number of items to drop
                    let amountToGive = Math.floor(Math.random() * (oreData.max - oreData.min + 1)) + oreData.min;

                    // Give items to the player
                    let dropItem = new ItemStack(oreData.drop, amountToGive);
                    player.getComponent("inventory").container.addItem(dropItem);
                }
            }
        }
    }
}

const checkpoints = new Map();
// Function to set checkpoint and replace item
function setCheckpoint(player) {
    const location = player.location;
    
    // Save checkpoint
    checkpoints.set(player.id, { x: location.x, y: location.y, z: location.z });
    player.sendMessage("Checkpoint set!");

    // Replace item in inventory
    system.run(() => {
        player.runCommandAsync(`replaceitem entity @s slot.weapon.mainhand 0 jfc_apples:active_echo_apple`);
    });
}



// Function to teleport to checkpoint and clear it
function teleportToCheckpoint(player) {
    const checkpoint = checkpoints.get(player.id);
    
    if (checkpoint) {
        player.teleport(checkpoint, { dimension: player.dimension });
        checkpoints.delete(player.id);
        player.sendMessage("Teleported to checkpoint!");
    } else {
        player.sendMessage("No checkpoint set!");
    }
}



// Register the custom apple effect
world.beforeEvents.worldInitialize.subscribe((initEvent) => {
    if (initEvent.itemComponentRegistry?.registerCustomComponent) {
        // Define a map of item identifiers to their function names
        const appleFunctionRun = {
            "jfc_apples:ender": "ender_apple",
            "jfc_apples:experience": "experience_apple",
            "jfc_apples:heart": "hearts_apple",
            "jfc_apples:hero": "hero_apple",
            "jfc_apples:milk": "milk_apple",
            "jfc_apples:water": "water_apple",
            "jfc_apples:lava": "lava_apple",
            "jfc_apples:feather": "feather_apple",
            "jfc_apples:feast": "feast_apple",
            "jfc_apples:sponge": "sponge_apple",
            "jfc_apples:clearing": "clearing_apple",
            "jfc_apples:plague": "plague_apple",
            "jfc_apples:growing": "growing_apple",
            "jfc_apples:levitation": "levitation_apple",
            "jfc_apples:rotten": "rotten_apple",
            "jfc_apples:minion": "minion_apple",
            "jfc_apples:torch": "torch_apple",
            "jfc_apples:suspicious": "suspicious_apple",
            "jfc_apples:iron": "iron_apple",

            "jfc_apples:ore": "ore_apple" ,
            "jfc_apples:inactive_echo": "inactive_echo_apple" ,
            "jfc_apples:active_echo": "active_echo_apple" 
        };

        // Loop through each item in the map and register its custom behavior
        for (const [itemIdentifier, functionLocation] of Object.entries(appleFunctionRun)) {
            initEvent.itemComponentRegistry.registerCustomComponent(itemIdentifier, {
                onConsume(ev) {
                    const player = ev.source; // The entity consuming the item
                    
                    if (player?.runCommandAsync) { 
                        // Send a message to all players showing which apple was consumed
                        player.runCommandAsync(`function jfc/apples/${functionLocation}`);

                        // If the ore apple is eaten, trigger the ore-breaking function
                        if (itemIdentifier === "jfc_apples:ore") {
                            mineNearbyOres(player);
                        }
                        if (itemIdentifier === "jfc_apples:inactive_echo") {
                            setCheckpoint(player);
                        }
                        if (itemIdentifier === "jfc_apples:active_echo") {
                            teleportToCheckpoint(player);
                        }
                    }
                }
            });
        }
    } else {
        // Fallback message if custom components aren't supported
        world.sendMessage("itemComponentRegistry or registerCustomComponent is undefined");
    }
});




world.afterEvents.playerBreakBlock.subscribe((event) => {
    const { brokenBlockPermutation, dimension, block } = event;

    // Check if the broken block was an oak leaf
    if (brokenBlockPermutation.type.id === "minecraft:oak_leaves") {

        // Generate a random number between 0 and 1
        let randomChance = Math.random();

        if (randomChance < 0.1) {
            dimension.spawnEntity("jfc_apples:rotten_minion", block.location);
        }

    }
});




system.runInterval(() => {
    const players = world.getPlayers();
  
    if (!players) return;
    
    const player = players[0]; // Get the first player

    if (!player) return;

  
    player.runCommandAsync(`function jfc/apples/torch_apple_glow`);
    }
  , 4);

